const solveSudoku = (board) => {
  const checkValidity = (value, row, column) => {
    for (let i = 0; i < 9; i++) {
      if (value == board[row][i] || value == board[i][column]) return false;
    }
    let xIndex = Math.floor(row / 3) * 3;
    let yIndex = Math.floor(column / 3) * 3;
    for (let i = 0; i < 9; i++) {
      if (value == board[xIndex][yIndex]) return false;
      xIndex++;
      if (xIndex % 3 === 0) {
        yIndex++;
        xIndex -= 3;
      }
    }
    return true;
  };

  const backtrace = (x, y) => {
    if (y === 9) {
      x++;
      // Base Case
      if (x === 9) {
        return true;
      }
      y = 0;
    }

    if (board[x][y] === ".") {
      for (let i = 1; i <= 9; i++) {
        let checkResult = checkValidity(i, x, y);
        if (checkResult) {
          board[x][y] = String(i);
          if (backtrace(x, y + 1)) return board;
          board[x][y] = ".";
        }
      }
    } else {
      if (backtrace(x, y + 1)) return board;
    }
  };
  return backtrace(0, 0);
};

const case1 = [
  ["5", "3", ".", ".", "7", ".", ".", ".", "."],
  ["6", ".", ".", "1", "9", "5", ".", ".", "."],
  [".", "9", "8", ".", ".", ".", ".", "6", "."],
  ["8", ".", ".", ".", "6", ".", ".", ".", "3"],
  ["4", ".", ".", "8", ".", "3", ".", ".", "1"],
  ["7", ".", ".", ".", "2", ".", ".", ".", "6"],
  [".", "6", ".", ".", ".", ".", "2", "8", "."],
  [".", ".", ".", "4", "1", "9", ".", ".", "5"],
  [".", ".", ".", ".", "8", ".", ".", "7", "9"],
];
const case2 = [
  [".", ".", "9", "7", "4", "8", ".", ".", "."],
  ["7", ".", ".", ".", ".", ".", ".", ".", "."],
  [".", "2", ".", "1", ".", "9", ".", ".", "."],
  [".", ".", "7", ".", ".", ".", "2", "4", "."],
  [".", "6", "4", ".", "1", ".", "5", "9", "."],
  [".", "9", "8", ".", ".", ".", "3", ".", "."],
  [".", ".", ".", "8", ".", "3", ".", "2", "."],
  [".", ".", ".", ".", ".", ".", ".", ".", "6"],
  [".", ".", ".", "2", "7", "5", "9", ".", "."],
];

const case5 = [
  [".", ".", ".", ".", ".", "7", ".", ".", "9"],
  [".", "4", ".", ".", "8", "1", "2", ".", "."],
  [".", ".", ".", "9", ".", ".", ".", "1", "."],
  [".", ".", "5", "3", ".", ".", ".", "7", "2"],
  ["2", "9", "3", ".", ".", ".", ".", "5", "."],
  [".", ".", ".", ".", ".", "5", "3", ".", "."],
  ["8", ".", ".", ".", "2", "3", ".", ".", "."],
  ["7", ".", ".", ".", "5", ".", ".", "4", "."],
  ["5", "3", "1", ".", "7", ".", ".", ".", "."],
];

const result = solveSudoku(case5);

console.log(result);
